package com.fidufosyga.rules;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import com.fidufosyga.context.Context;
import com.fidufosyga.rules.util.ValidarFecha;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author Julian
 */
public class ValidarEntidadesContributivoHomologadaNovedades extends AbstractRule {

    public static final String ENTIDADES_HOMOLOGADA = "ENTIDADES_CONTRIBUTIVO_HOMOLOGADA";
    public static final String ENTIDADES1 = "ENTIDADES_CONTRIBUTIVOS";

    String DATE_FORMAT = "dd/MM/yyyy";

    SimpleDateFormat sdf;

    public ValidarEntidadesContributivoHomologadaNovedades() {
        sdf = new SimpleDateFormat(DATE_FORMAT);
        sdf.setLenient(false);
    }

    public boolean performValidation(String field, String registro[],
            String nombreArchivo) {

        String campoDependienteTraslado = (String) (getParams()[0]);
        int campoDepTraslado = Integer.parseInt(campoDependienteTraslado);
        String fechaInicio = registro[campoDepTraslado];
        

        String fechaMinima = (String) getParams()[1];



        //Fecha de Afiliación
        if (fechaInicio.length() == 0) {
            return true;
        }

        if (fechaInicio.length() != 10 || fechaMinima.length() != 10) {
            return false;
        }

        if (!ValidarFecha.esFecha(fechaInicio)) {
            return false;
        }
        Date dateCampo = null;
        Date dateOtra = null;
        try {
            dateCampo = sdf.parse(fechaInicio);
            dateOtra = sdf.parse(fechaMinima);
        } catch (Exception e) {
            return false;
        }

        //Entidades Contributivo Homologadas
        if (Context.getContext().getAttribute(ENTIDADES_HOMOLOGADA) == null) {
            Properties defaultProps = new Properties();
            FileInputStream in;

            try {

                in = new FileInputStream(System.getProperty("user.dir")
                        + File.separator + "entidades" + File.separator
                        + "entidadesContributivoHomologada.properties");
                defaultProps.load(in);
                in.close();
                Context.getContext().addAttribute(ENTIDADES_HOMOLOGADA, defaultProps);

            } catch (FileNotFoundException e) {

                return false;
            } catch (IOException e) {

                return false;

            }

        }

        //Entidades Contributivo
        if (Context.getContext().getAttribute(ENTIDADES1) == null) {
            Properties defaultProps = new Properties();
            FileInputStream in;

            try {

                in = new FileInputStream(System.getProperty("user.dir")
                        + File.separator + "entidades" + File.separator
                        + "entidadesContributivo.properties");
                defaultProps.load(in);
                in.close();
                Context.getContext().addAttribute(ENTIDADES1, defaultProps);

            } catch (FileNotFoundException e) {

                return false;
            } catch (IOException e) {

                return false;

            }

        }

        //Validación
        if (((Properties) Context.getContext().getAttribute(ENTIDADES_HOMOLOGADA))
                .getProperty(field) != null) {


                if (dateCampo.before(dateOtra)) {
                    return true;
                } else {

                    return false;
                }
        }
        return true;
    }
}
